# ACE_Dynamic_Cached_Allocator< ACE_LOCK > Class Template Reference

A size-based allocator that caches blocks for quicker access. More...

`#include <Malloc_T.h>`

Inheritance diagram for ACE_Dynamic_Cached_Allocator< ACE_LOCK >:

[legend]
Collaboration diagram for ACE_Dynamic_Cached_Allocator< ACE_LOCK >:

[legend]
List of all members.

## Public Member Functions

| ACE_Dynamic_Cached_Allocator (size_t n_chunks, size_t chunk_size)
| ~ACE_Dynamic_Cached_Allocator (void)
| Clear things up.
void * | malloc (size_t nbytes=0)
virtual void * | calloc (size_t nbytes, char initial_value= '\0')
virtual void * | calloc (size_t n_elem, size_t elem_size, char initial_value= '\0')
void | free (void *)
| Return a chunk of memory back to free list cache.
size_t | pool_depth (void)
| Return the number of chunks available in the cache.

## Private Attributes

char * | pool_
ACE_Locked_Free_List< ACE_Cached_Mem_Pool_Node< char >, ACE_LOCK > | free_list_
size_t | chunk_size_
| Remember the size of our chunks.

## Detailed Description

### template<class ACE_LOCK>
class ACE_Dynamic_Cached_Allocator< ACE_LOCK >

A size-based allocator that caches blocks for quicker access.

This class enables caching of dynamically allocated, fixed-size chunks. Notice that the `chunk_size` must be greater than or equal to `sizeof (void*)` for this to work properly.

This class can be configured flexibly with different types of ACE_LOCK strategies that support the ACE_Thread_Mutex and ACE_Process_Mutex constructor API.

See also:
  ACE_Cached_Allocator

## Constructor & Destructor Documentation

template<class ACE_LOCK>
ACE_Dynamic_Cached_Allocator< ACE_LOCK >::ACE_Dynamic_Cached_Allocator | ( | size_t | n_chunks,
|  | size_t | chunk_size
| ) |

| Create a cached memory pool with n_chunks chunks each with chunk_size size.

template<class ACE_LOCK>
ACE_Dynamic_Cached_Allocator< ACE_LOCK >::~ACE_Dynamic_Cached_Allocator | ( | void |  | ) |

| Clear things up.

## Member Function Documentation

template<class ACE_LOCK>
void * ACE_Dynamic_Cached_Allocator< ACE_LOCK >::calloc | ( | size_t | n_elem,
|  | size_t | elem_size,
|  | char | initial_value = `'\0'`
| ) | `[virtual]`

| This method is a no-op and just returns 0 since the free list only works with fixed sized entities. Reimplemented from ACE_New_Allocator.

template<class ACE_LOCK>
void * ACE_Dynamic_Cached_Allocator< ACE_LOCK >::calloc | ( | size_t | nbytes,
|  | char | initial_value = `'\0'`
| ) | `[virtual]`

| Get a chunk of memory from free list cache, giving them initial_value. Note that nbytes is only checked to make sure that it's less or equal to chunk_size, and is otherwise ignored since calloc() always returns a pointer to an item of chunk_size. Reimplemented from ACE_New_Allocator.

template<class ACE_LOCK>
void ACE_Dynamic_Cached_Allocator< ACE_LOCK >::free | ( | void * |  | ) | `[virtual]`

| Return a chunk of memory back to free list cache. Reimplemented from ACE_New_Allocator.

template<class ACE_LOCK>
void * ACE_Dynamic_Cached_Allocator< ACE_LOCK >::malloc | ( | size_t | nbytes = `0` | ) | `[virtual]`

| Get a chunk of memory from free list cache. Note that nbytes is only checked to make sure that it's less or equal to chunk_size, and is otherwise ignored since malloc() always returns a pointer to an item of chunk_size size. Reimplemented from ACE_New_Allocator.

template<class ACE_LOCK>
ACE_INLINE size_t ACE_Dynamic_Cached_Allocator< ACE_LOCK >::pool_depth | ( | void |  | ) |

| Return the number of chunks available in the cache.

## Member Data Documentation

template<class ACE_LOCK>
size_t ACE_Dynamic_Cached_Allocator< ACE_LOCK >::chunk_size_ `[private]`

| Remember the size of our chunks.

template<class ACE_LOCK>
ACE_Locked_Free_List<ACE_Cached_Mem_Pool_Node<char>, ACE_LOCK> ACE_Dynamic_Cached_Allocator< ACE_LOCK >::free_list_ `[private]`

| Maintain a cached memory free list. We use `char` as template parameter, although sizeof(char) is usually less than sizeof(void*). Really important is that chunk_size must be greater or equal to sizeof(void*).

template<class ACE_LOCK>
char* ACE_Dynamic_Cached_Allocator< ACE_LOCK >::pool_ `[private]`

| Remember how we allocate the memory in the first place so we can clear things up later.

The documentation for this class was generated from the following files:

- Malloc_T.h
- Malloc_T.cpp
- Malloc_T.inl